# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:16:29 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_loco.db.tables.ino_res_search import iNoResSearch
from bs_loco.db.tables.ono_res_search import oNoResSearch

class dNoResSearch:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iNoResSearch()
        self.orec     = None

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  criteria: str) -> "dNoResSearch":
        """
        Execute the query by setting all the inputs.

        :param criteria: str
        :return: Self for convenience.
        """
        self.irec.criteria = criteria

        return self.exec()

    def exec(self, irec: iNoResSearch = None) -> "dNoResSearch":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("NoResSearch", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  nr.id,
  nr.filename,
  nr.mimetype,
  nr.content
from
  loco.nores nr
where
  (1=1)
  [criteria]
order by
  nr.id""")

        self._dbstmnt.dynamic("[criteria]", self.irec.criteria)

        self._dbstmnt.bind_out("id", str, 128)
        self._dbstmnt.bind_out("filename", str, 256)
        self._dbstmnt.bind_out("mimetype", str, 128)
        self._dbstmnt.bind_out("content", bytearray)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:NoRes, proc:Search, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec = oNoResSearch()

        self.orec.id = self._dbstmnt.result[0]
        self.orec.filename = self._dbstmnt.result[1]
        self.orec.mimetype = self._dbstmnt.result[2]
        self.orec.content = self._dbstmnt.result[3]

        return True

    def fetch_iter(self) -> oNoResSearch:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while self.fetch():
            yield self.orec

    def fetch_all(self, out_list: oNoResSearch.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(self.orec)

        return len(out_list)

