# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:16:29 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_loco.db.tables.corr_prov_key import tCorrProvKey
from bs_loco.db.tables.corr_prov import tCorrProv

class dCorrProvLockOne:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tCorrProvKey()
        self.orec     = None

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    async def exec_deft(self,
                        id: str,
                        corrtype_id: str) -> "dCorrProvLockOne":
        """
        Execute the query by setting all the inputs.

        :param id: str
        :param corrtype_id: str
        :return: Self for convenience.
        """
        self.irec.id = id
        self.irec.corrtype_id = corrtype_id

        return await self.exec()

    async def exec(self, irec: tCorrProvKey = None) -> "dCorrProvLockOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("CorrProvLockOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  id,
  corrtype_id,
  descr,
  status,
  cfg_schema,
  cfg,
  lastcfg_id,
  modified_by,
  tm_stamp
from
  loco.CorrProv
where
  id = :id and
  corrtype_id = :corrtype_id for update nowait""")

        self._dbstmnt.bind_in("id", self.irec.id, str, 16)
        self._dbstmnt.bind_in("corrtype_id", self.irec.corrtype_id, str, 16)

        self._dbstmnt.bind_out("id", str, 16)
        self._dbstmnt.bind_out("corrtype_id", str, 16)
        self._dbstmnt.bind_out("descr", str)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("cfg_schema", dict)
        self._dbstmnt.bind_out("cfg", dict)
        self._dbstmnt.bind_out("lastcfg_id", int, 8)
        self._dbstmnt.bind_out("modified_by", str, 128)
        self._dbstmnt.bind_out("tm_stamp", datetime.datetime)

        await self._dbcon.lock(self._dbstmnt)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:CorrProv, proc:LockOne, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec = tCorrProv()

        self.orec.id = self._dbstmnt.result[0]
        self.orec.corrtype_id = self._dbstmnt.result[1]
        self.orec.descr = self._dbstmnt.result[2]
        self.orec.status = self._dbstmnt.result[3]
        self.orec.cfg_schema = self._dbstmnt.result[4]
        self.orec.cfg = self._dbstmnt.result[5]
        self.orec.lastcfg_id = self._dbstmnt.result[6]
        self.orec.modified_by = self._dbstmnt.result[7]
        self.orec.tm_stamp = self._dbstmnt.result[8]

        return True

    async def fetch_iter(self) -> tCorrProv:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while await self.fetch():
            yield self.orec

    async def fetch_all(self, out_list: tCorrProv.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while await self.fetch():
            out_list.append(self.orec)

        return len(out_list)

